/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSocketServer_template.c => src/tSocketServer.c
 * Τ褦̾, եѹƤ齤ޤ
 *
 * °ޥ #_CAAM_#
 * port_no          int16_t          ATTR_port_no    
 * sd               int_t            VAR_sd          
 *
 * #[</PREAMBLE>]# */

#include "tSocketServer_tecsgen.h"

#include <errno.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>

#ifndef E_OK
#define	E_OK	0		/* ｪλ */
#define	E_ID	(-18)	/* IDֹ */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eC1
 * entry port: eC1
 * signature:  sChannel
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eC1_open
 * name:         eC1_open
 * global_name:  tSocketServer_eC1_open
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC1_open(CELLIDX idx, const int8_t* arg, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	short   port_no;
    int     ssoc, soc;
    struct sockaddr_in addr={ AF_INET };

	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	syslog( LOG_INFO, "tSocketServer: open" );

    ssoc=socket(AF_INET,SOCK_STREAM,0);
    if(ssoc<0){
    	syslog( LOG_INFO, "tSocketServer: socket failed" );
		return E_RPC;
	}

    addr.sin_port = htons(atoi(arg));
    addr.sin_addr.s_addr = INADDR_ANY;
    if(bind(ssoc,(struct sockaddr*)&addr,sizeof(addr))<0){
    	syslog( LOG_INFO, "tSocketServer: bind failed" );
		return E_RPC;
	}

    if(listen(ssoc, 1 )<0){
    	syslog( LOG_INFO, "tSocketServer: listen failed" );
		return E_RPC;
	}

    soc=accept(ssoc, NULL, NULL);
    if(soc<0){
    	syslog( LOG_INFO, "tSocketServer: accept failed" );
		return E_RPC;
	}
	syslog( LOG_INFO, "tSocketServer: accepted" );

    close( ssoc );
	VAR_sd = soc;

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_close
 * name:         eC1_close
 * global_name:  tSocketServer_eC1_close
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC1_close(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	syslog( LOG_INFO, "tSocketServer: close" );
	if( close( VAR_sd ) < 0 )
		ercd = E_OBJ;

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_reset
 * name:         eC1_reset
 * global_name:  tSocketServer_eC1_reset
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC1_reset(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	syslog( LOG_INFO, "tSocketServer: reset" );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_send
 * name:         eC1_send
 * global_name:  tSocketServer_eC1_send
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC1_send(CELLIDX idx, const int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	int     sz;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	syslog( LOG_INFO, "tSocketServer: send" );
	while(size>0){
		if((sz=write( VAR_sd, buf, (size_t)size )) < 0 ){
			ercd = E_RPC;
			break;
		}
		else{
			size -= sz;
		}
	}

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_flush
 * name:         eC1_flush
 * global_name:  tSocketServer_eC1_flush
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC1_flush(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_receive
 * name:         eC1_receive
 * global_name:  tSocketServer_eC1_receive
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER_UINT
eC1_receive(CELLIDX idx, int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	ER_UINT sz;
	CELLCB	*p_cellcb;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	if( (sz=read( VAR_sd, buf, (size_t)size )) < 0 )
		ercd = E_RPC;
	else
		ercd = sz;

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_end_receive
 * name:         eC1_end_receive
 * global_name:  tSocketServer_eC1_end_receive
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eC1_end_receive(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */

	return(ercd);
}

