#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#
#   Copyright (C) 2008 by TOPPERS Project
#--  
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: types.rb 92 2008-05-26 01:43:38Z okuma-top $
#++

class Type
# @qualifier::		:VOLATILE, :CONST

  def set_qualifier( qualifier )
    if qualifier != :VOLATILE && qualifier != :CONST then
      raise InternalError
    end
    @qualifier = qualifier
  end

  def get_qualifier
    @qualifier
  end

  def is_const?
    @qualifier == :CONST
  end

  #=== å
  #    ʷɤå
  def check
    # ˸꤬С顼ʸ֤
  end

  #===  ǽå
  #     attribute ʤɽǽåʷФʽҤͿƤ뤫
  #ident::        string                ѿ̿
  #         initialize   Expression, Array of initializer or C_EXP
  #                                            ͡C_EXP ͿΤ IntType ξΤ
  #         kind         symbol (:ATTRIBUTE, :VAR, :CONSTNAT )
  #         attribute    NameList              kind == :VAR ΤȤȤǤ attribute
  def check_init( ident, initializer, kind, attribute = nil )
    #
  end

  #=== פ뤫Υå
  # ̾λ̤ǥå
  # typedef 줿̤ǰפ򸫤뤿ᡢηƱǤⷿ̾ۤʤ԰פȤʤ
  def equal? type2
    return ( get_type_str == type2.get_type_str ) && ( get_type_str_post == type2.get_type_str_post )
  end

  #=== η
  # typedef 줿ξ硢θη֤.
  # ʳϡʬȤ֤
  # (DefinedType Ǥܥ᥽åɤС饤ɤ)
  def get_original_type
    return self
  end
end

class DefinedType < Type
#  @type_name::
#  @type::

  def initialize( type_name )
    @type_name = type_name

    # mikan type_name  path ˤʤäƤʤ
#    @type = Namespace.find( type_name )
    @type = Namespace.find( [ type_name ] )

    if @type.class != Typedef then
      raise NotTypedef
    end
  end

  def get_type
    return @type.get_declarator.type
  end

  def get_type_str
    @type_name
  end

  def get_type_str_post
    ""
  end

  def get_size
    return @type.get_declarator.type.get_size
  end

  def get_original_type
    type = @type.get_declarator.type
#    while type.kind_of?( DefinedType )
#      type = type.get_type
#    end
    #    return type
    return type.get_original_type
  end

  def check	# ̣Ū꤬Сʸ֤
    nil    # typedef ʳǰ̣åƤ
  end

  def check_init( ident, initializer, kind, attribute = nil )
    get_type.check_init( ident, initializer, kind, attribute = nil )
  end
     
  def show_tree( indent )
    indent.times { print "  " }
    if @type == nil then
      puts "DefinedType: #{@type_name} is missing, qualifier: #{@qualifier}"
    else
      puts "DefinedType: #{@type_name}, qualifier: #{@qualifier}"
    end
    @type.show_tree( indent + 1 )
  end
end

class VoidType < Type

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  def check_init( ident, initializer, kind, attribute = nil )
    Generator.error( "#{ident}: void type variable cannot have initializer" )
  end

  def get_type_str
    "void"
  end

  def get_type_str_post
    ""
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "VoidType"
  end
end

class BoolType < Type

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  def get_type_str
    "bool_t"
  end

  def get_type_str_post
    ""
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "BoolType"
  end
end

class IntType < Type
#  @bit_size::		-1: char, -2: short, -3: int, -4: long, -5: intptr_t
#			8, 16, 32, 64, 128
#  @sign::		:SIGNED, :UNSIGNED, nil(char ξΤ)

  def initialize( bit_size )
    @bit_size = bit_size
    if bit_size != -1 then
      @sign = :SIGNED  # set default
    else
      @sign = nil  # char
    end
  end

  def set_sign( sign )
    @sign = sign
  end

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  def check_init( ident, initializer, kind, attribute = nil )
    if initializer.instance_of?( Expression ) then
      val = initializer.eval_const( nil, attribute )
      if val == nil then
        Generator.error( "#{ident}: initializer is not constant" )
        return
      end

      if val != Integer( val ) then
        Generator.error( "#{ident}: #{val}: not integer" )
        return
      end

      if @sign == :SIGNED then
        case @bit_size
        when -1, -2, -3, -4, -5
          return
        when 8, 16, 32, 64, 128
          if val >= ( 1 << ( @bit_size - 1 )) then
            Generator.error( "#{ident}: too large (max=#{((1 << (@bit_size-1))-1)})" )
            return
          elsif val < - ( 1 << ( @bit_size - 1 )) then
            Generator.error( "#{ident}: too large negative value (min=-#{1 << (@bit_size-1)})" )
            return
          end
        end

      else   # @sign == :UNSIGNED || @sign == nil (char ξ)
        if val < 0 then
          Generator.error( "#{ident}: negative value for unsigned" )
          return
        end

        case @bit_size
        when -1, -2, -3, -4, -5
          return
        when 8, 16, 32, 64, 128
          if val >= ( 1 << @bit_size ) then
            Generator.error( "#{ident}: too large (max=#{1 << @bit_size})" )
            return
          end
        end
      end

    elsif( initializer.instance_of?( C_EXP ) ) then

    else
      Generator.error( "#{ident}: unsuitable initializer for scalar type" )
    end
  end

  #=== C ˤ뷿̾ʽդ
  def get_type_str
    str = ""
    case @qualifier
    when :VOLATILE
      str = "volatile "
    when :CONST
      str = "const "
    end

    if @sign == :UNSIGNED then
      sign = "u"
    end

    if $old_mode then
      # OLD_MODE
      case @bit_size
      when -1      # char 
#         true ˤʤ뤳ȤϤʤʤä(070402)
#        if @sign == :SIGNED then
#          sign = "s"
#        end
        str = "#{str}tecs_#{sign}char"
      when -2      # short 
        str = "#{str}tecs_#{sign}short"
      when -3      # int 
        str = "#{str}tecs_#{sign}int"
      when -4      # long 
        str = "#{str}tecs_#{sign}long"
      when -5      # intptr 
        str = "#{str}tecs_#{sign}intptr"
      when 8, 16, 32, 64, 128     # int8, int16, int32, int64, int128 
        str = "#{str}tecs_#{sign}int#{@bit_size}"
      end
    else
      # NEW_MODE
      case @bit_size
      when -11     # char (obsolete)
#         true ˤʤ뤳ȤϤʤʤä(070402)
#        if @sign == :SIGNED then
#          sign = "s"
#        end
#        str = "#{str}tecs_#{sign}char"
        str = "#{str}char"
      when -1      # char_t 
        str = "#{str}char_t"
      when -2      # short 
        if @sign == :UNSIGNED then
          str = "#{str}unsigned "
        end
        str = "#{str}short"
      when -3      # int 
        str = "#{str}#{sign}int_t"
      when -4      # long 
        str = "#{str}#{sign}long_t"
      when -5      # intptr 
        str = "#{str}#{sign}intptr_t"
#      when 8                   # int8 
#        str = "#{str}#{sign}int_least#{@bit_size}_t"
#      when 16, 32, 64, 128     # int16, int32, int64, int128 
      when 8, 16, 32, 64, 128     # int16, int32, int64, int128 
        str = "#{str}#{sign}int#{@bit_size}_t"
      end
    end

    return str
  end

  #=== C ˤ뷿̾ʸʸ
  def get_type_str_post
    ""
  end

  #=== bit_size 
  #    ֤ͤ @bit_size λͤ򻲾
  def get_bit_size
    @bit_size
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "IntType bit_size: #{@bit_size} sign: #{@sign} qualifier: #{@qualifier}"
  end
end

class FloatType < Type
#  @bit_size::         32, 64, (80)

  def initialize( bit_size )
    @bit_size = bit_size
  end

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  # mikan Float  C_EXP б (generate.rb ˤѹɬ)
  def check_init( ident, initializer, kind, attribute = nil )
    # Фͤ˸꤬С顼ʸ֤
    if initializer.instance_of?( Expression ) then
      val = initializer.eval_const( nil, attribute )
      if val == nil then
        Generator.error( "#{ident}: initializer is not constant" )
        return
      end
    else
      Generator.error( "#{ident}: unsuitable initializer for scalar type" )
      return
    end
    return
  end

  def get_type_str
    str = ""
    case @qualifier
    when :VOLATILE
      str = "volatile "
    when :CONST
      str = "const "
    end

    case @bit_size
    when 32
      str = "#{str}tecs_float"
    when 64
      str = "#{str}tecs_double"
    end
    return str
  end

  def get_type_str_post
    ""
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "FloatType bit_size: #{@bit_size} qualifier: #{@qualifier}"
  end
end

class EnumType < Type # mikan
#  @bit_size::		-1: enum
#			8, 16, 32, 64, 128
#  @element::		[]
#  @element_val::	[]

  def initialize( bit_size )
    @bit_size = bit_size
  end

  def check
   # mikan enum check
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "EnumType bit_size: #{@bit_size} qualifier: #{@qualifier}"
    # mikan element
  end
end

class StructType < Type
#  @tag::
#  @define::  true if define, false if refer
#  @members_decl:: NamedList
#  @definition:: StructType

  @@structtype_current_stack = []
  @@structtype_current_sp = -1

  def initialize( tag = nil )
    @tag = tag
    @@structtype_current_sp += 1
    @@structtype_current_stack[@@structtype_current_sp] = self
  end

  def self.set_define( define )
    @@structtype_current_stack[@@structtype_current_sp].set_define( define )
  end

  def set_define( define )
    @define = define
    if @define then
      @members_decl = NamedList.new( nil, "in struct #{@tag}" )
      if @tag then
        Namespace.new_structtype( self )
      end
    else
      @definition = Namespace.find_tag( @tag )
      if @definition == nil then
        Generator.error( "'#{@tag}': struct not defined" )
      end
    end
  end

  def self.new_member( member_decl )
    @@structtype_current_stack[@@structtype_current_sp].new_member( member_decl )
  end

  def new_member( member_decl )
    @members_decl.add_item( member_decl )
  end

  def check	# ̣Ū꤬Сʸ֤
    nil
  end

  # mikan Float  C_EXP б (generate.rb ˤѹɬ)
  def check_init( ident, initializer, kind, attribute = nil )

    st = Namespace.find_tag( @tag )
    if st == nil then
      Generator.error( "struct #{@tag}: not defined" )
      return
    end

    if initializer.instance_of?( Array ) then
      i = 0
      st.get_members_decl.get_items.each { |d|
        if initializer[i] then
          d.type.check_init( "#{ident}.#{d.identifier}", initializer[i], kind )
        end
        i += 1
      }
    else
      Generator.error( "#{ident}: unsuitable initializer for struct" )
    end
  end

  def self.end_of_parse()
    @@structtype_current_sp -= 1
  end

  def get_name
    @tag
  end

  def get_type_str      # mikan struct get_type_str
    str = ""
    case @qualifier
    when :VOLATILE
      str = "volatile "
    when :CONST
      str = "const "
    end

    if @tag then
      # typedef struct tag StructType; ηξ
      # struct Τϡ̤
      return "#{str} struct #{@tag} "

    else
      # typedef struct { int a; } StructType; ηξ
      str += "struct {\n"
      @members_decl.get_items.each{ |i|
        str += sprintf( "    %-8s %s%s;\n", "#{i.get_type.get_type_str}", "#{i.get_name}", "#{i.get_type.get_type_str_post}" )
      }
      str += "} "

      return str

    end
  end

  def get_type_str_post
    ""
  end

  def get_members_decl
    return @members_decl if @members_decl

    st = Namespace.find_tag( @tag )
    if st then
      return st.get_members_decl
    end

    return nil
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "StructType tag: #{@tag} qualifier: #{@qualifier}"
    if @define then
      @members_decl.show_tree( indent + 1 )
    end
  end
end

class FuncType < Type
#  @paramlist::  ParamList
#  @type:: return type : PtrType, ArrayType, FuncType, IntType, FloatType, ...
#  @async:: bool: true, false

  def initialize( paramlist = nil )
    @paramlist = paramlist
    if paramlist then
      paramlist.check_param
    end
  end

  def check	# ̣Ū꤬Сʸ֤
    if @type.class == ArrayType then	# ֤ؿ
      return "function returning array"
    elsif @type.class == FuncType then	# ؿ֤ؿ
      return "function returning function"
    end
    return nil
  end

  def check_init( ident, initializer, kind, attribute = nil )
    Generator.error( "#{ident}: cannot initialize function pointer" )
    return
  end

  def set_type( type )
    unless @type then
      @type = type
    else
      @type.set_type( type )
    end
  end

  def get_type
    @type
  end

  def get_type_str
    return @type.get_type_str
  end

  def get_type_str_post    # mikan    FuncType ξ硢줬ƽФꤷƤʤ
    ""
  end

  def get_paramlist
    @paramlist
  end

  def set_async( async )
    @async = async
  end

  def show_tree( indent )
    indent.times { print "  " }
    if @async then
      puts "FunctType:  async: true"
    else
      puts "FunctType:  async: false"
    end
    if @paramlist then
      @paramlist.show_tree( indent + 1 )
    end
    (indent+1).times { print "  " }
    puts "return type:"
    @type.show_tree( indent + 2 )
  end
end

class ArrayType < Type
#  @type:: element type :  ArrayType, FuncType, IntType, FloatType, ...
#  @subscript:: Expression

  attr_reader :type

  def initialize( subscript = nil )
    @subscript = subscript
  end

  def set_type( type )
    unless @type then
      @type = type
    else
      @type.set_type( type )
    end
  end

  def get_type
    @type
  end

  def get_subscript
    @subscript
  end

  def get_type_str
    return @type.get_type_str
  end

  def get_type_str_post
    "[#{@subscript.eval_const(nil)}]"
  end

  def check	# ̣Ū꤬Сʸ֤
    if @type.class == FuncType then		# ؿ
      return "array of function"
    elsif @type.class == ArrayType then	# źʤ
      unless @type.get_subscript then
        return "subscript not specified"
      end
    end

    return nil
  end

  def check_init( ident, initializer, kind, attribute = nil )
    if ( initializer.instance_of?( Array ) ) then
      index = 0
      initializer.each{ |i|
        @type.check_init( "#{ident}[#{index}]", i, kind, attribute = nil )
        index += 1
      }
    else
      Generator.error( "#{ident}: unsuitable initializer for array" )
    end
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "ArrayType:"
    (indent+1).times { print "  " }
    puts "type:"
    @type.show_tree( indent + 2 )
    (indent+1).times { print "  " }
    puts "subscript:"
    if @subscript then
      @subscript.show_tree( indent + 2 )
    else
      (indent+2).times { print "  " }
      puts "no subscript"
    end
  end
end

class PtrType < Type
#  @type:: refer to : PtrType, FuncType, ArrayType, IntType, FloatType, ...
#  @size:: Expr, or nil if not specified
#  @count:: Expr, or nil if not specified
#  @string:: Expr or -1(if size not specified) string , or nil if not specified

  def initialize( referto = nil )
    @type   = referto
    @size   = nil
    @count  = nil
    @string = nil
  end

  def set_type( type )
    unless @type then
      @type = type
    else
      @type.set_type( type )	#  type 
    end
  end

  def get_type_str
    return "#{@type.get_type_str}*"
  end

  def get_type_str_post
    ""
  end

  def check	# ̣Ū꤬Сʸ֤
    @type.check
  end

  def check_init( ident, initializer, kind, attribute = nil )
    if ( initializer.instance_of?( Expression ) ) then
      # mikan åǤʤ
    elsif ( initializer.instance_of?( Array ) ) then
      i = 0
      initializer.each { |ini|
        @type.check_init( "#{ident}[#i]", ini, kind, attribute = nil )
        i += 1
      }
    elsif( initializer.instance_of?( C_EXP ) ) then

    else
      Generator.error( "#{ident}: unsuitable initializer for pointer" )
    end
  end

  def get_referto
    @type
  end

  def set_scs( size, count, string )
    @size = size
    @count = count

    # string ϺǤ⺸¦ ptr ˺Ѥ
    if @type.kind_of?( PtrType ) then
      @type.set_scs( nil, string, nil )
    else
      @string = string
    end
  end

  def get_size
    @size
  end

  def get_count
    @count
  end

  def get_string
    @string
  end

  def get_type
    @type
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "PtrType: qualifier: #{@qualifier}"
    (indent+1).times { print "  " }
    if @size then
      print "size: #{@size.eval_const(nil)}, "
    else
      print "size: nil, "
    end
    if @count then
      print "count: #{@count.eval_const(nil)}, "
    else
      print "count: nil, "
    end
    if @string then
      if @string.instance_of?( Expr ) then
        print "string: #{@string.eval_const}\n"
      else
        print "string: yes\n"
      end
    else
      print "string: nil\n"
    end

    (indent+1).times { print "  " }
    puts "type:"
    @type.show_tree( indent + 2 )
  end

end

