#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2009 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: TracePlugin.rb 101 2008-05-27 09:21:48Z okuma-top $
#++

# mikan through plugin: namespace θƤʤ
class TracePlugin < ThroughPlugin

  def gen_through_cell_code( file )

    gen_plugin_decl_code( file )

    file.print <<EOT
cell #{@ct_name} #{@cell_name} {
  #{@call_port_name} = #{@next_cell_name}.#{@next_cell_port_name};
};
EOT

  end

  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

    if ! func_type.get_type.kind_of?( VoidType ) then
      file.print( "  #{func_type.get_type_str}  retval;\n" )
    end

    if ! b_singleton then

      file.print <<EOT
  #{ct_name}_CB *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = #{global_ct_name}_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }

EOT
    end

    p "celltype_name, sig_name, func_name, func_global_name"
    p "#{ct_name}, #{sig_name}, #{func_name}, #{func_global_name}"

    file.print( "  puts( \"Enter: #{ct_name}.#{ep_name}.#{func_name} signature: #{sig_name}\" );\n" )
    print_params( params, file, 0, :IN )

    delim = ""
    if ! func_type.get_type.kind_of?( VoidType ) then
      file.print( "  retval = " )
    end

    file.print( "#{@call_port_name}_#{func_name}(" )

#    if ( ! b_singleton ) then
#      file.print( " tecs_this" )
#      delim = ","
#    end

    params.each{ |param|
      file.printf( "#{delim} #{param.get_name}" )
      delim = ","
    }
    file.print( " );\n" )

    file.print( "  puts( \"Leave: #{ct_name}.#{ep_name}.#{func_name} signature: #{sig_name}\" );\n" )
    print_params( params, file, 0, :OUT )

    if( ! func_type.get_type.kind_of?( VoidType ) ) then
      print_param( "retval", func_type.get_type, file, 0, :RETURN, nil, nil)
      file.print( "  return retval;\n" )
    end

  end

  def print_params( params, file, nest, direction )
    params.each{ |param|
      dir = param.get_direction
      if( direction == :IN )then
        case dir
        when :IN, :INOUT, :SEND
          print_param( param.get_name, param.get_type, file, nest, dir, nil, nil )
        end
      else
        case dir
        when :OUT, :INOUT, :RECEIVE
          print_param( param.get_name, param.get_type, file, nest, dir, nil, nil )
        end
      end
    }
  end

  def print_param( name, type, file, nest, direction, outer, outer2 )
    indent = "  " * ( nest + 1 )

    case type
    when DefinedType
      print_param( name, type.get_type, file, nest, direction, outer, outer2 )
    when VoidType
    when BoolType
      file.print( "  printf( \"#{indent}[#{direction}]#{type.get_type_str} #{outer}#{name}#{outer2} = %d;\\n\", #{outer}#{name}#{outer2} );\n" )
    when IntType
      file.print( "  printf( \"#{indent}[#{direction}]#{type.get_type_str} #{outer}#{name}#{outer2} = %ld;\\n\", (long)#{outer}#{name}#{outer2} );\n" )
    when FloatType
      file.print( "  printf( \"#{indent}[#{direction}]#{type.get_type_str} #{outer}#{name}#{outer2} = %g;\\n\", (double)#{outer}#{name}#{outer2} );\n" )
    when EnumType  # mikan EnumType

    when StructType
      members_decl =type.get_members_decl
      members_decl.get_items.each { |m|
        print_param( m.get_name, m.get_type, file, nest, direction, "#{outer}#{name}.", nil )
      }
    when FuncType  # mikan FuncType
    when ArrayType # mikan ArrayType
    when PtrType

      se = type.get_size
      ce = type.get_count
      max_loop = 8

      if se then
        loop_count = "(((#{se.to_s})>#{max_loop}) ? #{max_loop} : (#{se.to_s}))"
        file.print( "  printf( \"#{indent}size_is(#{se.to_s})=%d\\n\", #{se.to_s} );\n" )
      elsif ce then
        loop_count = "(((#{ce.to_s})>#{max_loop}) ? #{max_loop} : (#{ce.to_s})) "
        file.print( "  printf( \"#{indent}count_is(#{ce.to_s})=%d\\n\", #{ce.to_s} );\n" )
      else
        loop_count = nil
      end

      # mikan PtrType: string

      referto = type.get_referto
      type = referto
      if type.kind_of?( DefinedType ) then
        type = type.get_original_type
      end

      if loop_count then
        file.print <<EOT
  {
     int i__, loop_count__ = #{loop_count};
     for( i__ = 0; i__ < loop_count__; i__++ ){
EOT
      end

      case type
      when StructType
        members = type.get_members_decl
        members.get_items.each { |m|
          if loop_count then
            outer = "#{name}[i__]."
          else
            outer = "#{name}->"
          end
          print_param( m.get_name, m.get_type, file, nest, direction, outer, nil )
        }
      when FuncType  # mikan FuncType
      when ArrayType # mikan ArrayType
      when BoolType, IntType, FloatType, EnumType
        if loop_count then
          outer = nil
          outer2 = "[i__]"
        else
          outer = "*"
          outer2 = nil
        end
        print_param( name, type, file, nest, direction, outer, outer2 )
      when PtrType
        type = type.get_referto
        if loop_count then
          outer = "(*"
          outer2 = ")[i__]"
        else
          outer = "**"
          outer2 = nil
        end
        print_param( name, type, file, nest, direction, outer, outer2 )
      end

      if loop_count then
        file.print <<EOT

     } /* for ( i__ ) */
  }
EOT
      end
    end
  end
end


