/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: t_stddef.h 8 2006-10-29 12:01:12Z asp $
 */

/*
 *		TOPPERSʃCN[ht@C
 *
 *  TOPPERS֘ÂׂẴ\[Xt@CŃCN[hׂCN[h
 *  t@CDẽJ[l\tgEFAiŋʂɗp邱Ƃz
 *  ĂDTOPPERS̊ẽJ[l\tgEFAiŋʂɗpf[
 *  ^^C萔C}N̒`Ȃǂ܂ށD
 *
 *  AZũ\[Xt@CVXeRtBM[Vt@
 *  C炱̃t@CCN[h鎞́CTOPPERS_MACRO_ONLY
 *  `ĂDɂC}N`ȊO悤ɂȂĂD܂C
 *  NULL̒`D
 *
 *  ̃t@CCN[hOɃCN[hĂׂt@C
 *  ͂ȂD
 */

#ifndef TOPPERS_T_STDDEF_H
#define TOPPERS_T_STDDEF_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ^[Qbgˑ
 */
/* #include "target_stddef.h" */

/*
 *  C/EC++throw()ɑΏ邽߂̒`
 */
#if !defined(__cplusplus) || defined(__embedded_cplusplus)
#define throw()
#endif

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ^[Qbgˑ̃f[^^ƃ}ÑftHg`
 */
#ifndef TOPPERS_bool
#define TOPPERS_bool	int				/* u[^ */
#endif /* TOPPERS_bool */

#ifndef TOPPERS_size
#define TOPPERS_size	uintptr_t		/* TCY^ */
#endif /* TOPPERS_size */

#ifndef TOPPERS_fp
struct TOPPERS_dummy_t { int TOPPERS_dummy_field; };
typedef	void			(*TOPPERS_fp_t)(struct TOPPERS_dummy_t);
#define TOPPERS_fp		TOPPERS_fp_t	/* vŐNԒn */
#endif /* TOPPERS_fp */

#ifndef CHAR_BIT
#define CHAR_BIT		8				/* char^̃rbg */
#endif /* CHAR_BIT */

/*
 *  ʃf[^^
 */
typedef unsigned char	char_t;		/* */
typedef signed int		int_t;		/* RȃTCY̕t */
typedef unsigned int	uint_t;		/* RȃTCY̕ */

typedef signed long		long_t;		/* ߂̃TCY̕t */
typedef unsigned long	ulong_t;	/* ߂̃TCY̕ */

typedef TOPPERS_bool	BOOL;		/* ^Ul */
typedef	TOPPERS_size	SIZE;		/* ̈̃TCY */
typedef	TOPPERS_fp		FP;			/* vŐNԒn */

typedef int_t			FN;			/* @\R[h */
typedef	int_t			ER;			/* G[R[h */
typedef	int_t			ID;			/* IuWFNgIDԍ */
typedef	uint_t			ATR;		/* IuWFNg̑ */
typedef	uint_t			STAT;		/* IuWFNg̏ */
typedef	uint_t			MODE;		/* T[rXR[̓샂[h */
typedef	int_t			PRI;		/* Dx */

typedef	int_t			TMO;		/* ^CAEgw */
typedef	uint_t			RELTIM;		/* Ύ */
typedef	ulong_t			SYSTIM;		/* VXe */
typedef	ulong_t			SYSUTIM;	/* \]pVXe */

typedef	int_t			ER_BOOL;	/* G[R[h܂͐^Ul */
typedef	int_t			ER_ID;		/* G[R[h܂IDԍ */
typedef	int_t			ER_UINT;	/* G[R[h܂͕ */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ʒ萔
 *
 *  TOPPERS_MACRO_ONLY̎ɂ́CNULL`ȂD́CVXeR
 *  tBM[Vt@CꍇɂNULL`Ă͂Ȃ
 *  ߂łD
 */
#ifndef TOPPERS_MACRO_ONLY
#ifndef NULL
#define NULL		0			/* |C^ */
#endif /* NULL */
#endif /* TOPPERS_MACRO_ONLY */

#define TRUE		1			/* ^ */
#define FALSE		0			/* U */
#define E_OK		0			/* I */

/*
 *  CG[R[h
 */
#define E_SYS		(-5)		/* VXeG[ */
#define E_NOSPT		(-9)		/* T|[g@\ */
#define E_RSFN		(-10)		/* \@\R[h */
#define E_RSATR		(-11)		/* \񑮐 */
#define E_PAR		(-17)		/* p[^G[ */
#define E_ID		(-18)		/* sIDԍ */
#define E_CTX		(-25)		/* ReLXgG[ */
#define E_MACV		(-26)		/* ANZXᔽ */
#define E_OACV		(-27)		/* IuWFNgANZXᔽ */
#define E_ILUSE		(-28)		/* T[rXR[sgp */
#define E_NOMEM		(-33)		/* s */
#define E_NOID		(-34)		/* IDԍs */
#define E_OBJ		(-41)		/* IuWFNgԃG[ */
#define E_NOEXS		(-42)		/* IuWFNg */
#define E_QOVR		(-43)		/* L[COI[o[t[ */
#define E_RLWAI		(-49)		/* ҂Ԃ̋ */
#define E_TMOUT		(-50)		/* |[Os܂̓^CAEg */
#define E_DLT		(-51)		/* ҂IuWFNg̍폜 */
#define E_CLS		(-52)		/* ҂IuWFNg̏ԕω */
#define E_WBLK		(-57)		/* mubLOt */
#define E_BOVR		(-58)		/* obt@I[o[t[ */

/*
 *  IuWFNg
 */
#define TA_NULL		0U			/* IuWFNgw肵Ȃ */

/*
 *  ^CAEgw
 */
#define TMO_POL		0			/* |[O */
#define TMO_FEVR	(-1)		/* iv҂ */
#define TMO_NBLK	(-2)		/* mubLO */

/*
 *  G[R[hE}N
 *
 *  ȉ̃}N`́Ct2̕␔ŕ\ĂCEVtg
 *  Zqi>>jZpVtg邱Ƃ肵ĂDłȂJ
 *  ł́Ctarget_stddef.hł̒`㏑Ȃ΂ȂȂD
 *
 *  MERCD}N̒`́CCG[R[hł邱Ƃ肵ĂD
 *  łȂꍇC2̒`vȂȂD
 */
#ifndef ERCD
#define ERCD(mercd, sercd) \
				((ER)((((uint_t) sercd) << 8) | (((uint_t) mercd) & 0xffU)))
#endif /* ERCD */

#ifndef MERCD
#ifdef INT8_MAX
#define MERCD(ercd)		((ER)((int8_t)(ercd)))
#else /* INT8_MAX */
#define MERCD(ercd)		((ER)(((uint_t) ercd) | ~0xffU))
#endif /* INT8_MAX */
#endif /* MERCD */

#ifndef SERCD
#define SERCD(ercd)		((ER)((ercd) >> 8))
#endif /* SERCD */

/*
 *  ^Ɋւo߂̃}N̒`
 */
#ifndef offsetof
#define	offsetof(structure, field)	((uintptr_t) &(((structure *) 0)->field))
#endif /* offsetof */

#ifndef alignof
#define alignof(type)	offsetof(struct { char field1; type field2; }, field2)
#endif /* alignof */

/*
 *  ACg`FbN}N
 */
#ifndef ALIGN_TYPE
#define ALIGN_TYPE(addr, type) \
						((((uintptr_t)(addr)) & (alignof(type) - 1)) == 0U)
#endif /* ALIGN_TYPE */

/*
 *  assert}N̒`
 */
#undef assert
#ifndef NDEBUG
#define assert(exp)		((void)((exp) ? 0 : (TOPPERS_assert_fail(#exp, \
							__FILE__, __LINE__), TOPPERS_assert_abort(), 0)))
#else /* NDEBUG */
#define assert(exp)		((void) 0)
#endif /* NDEBUG */

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_T_STDDEF_H */
