#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: expression.rb 92 2008-05-26 01:43:38Z okuma-top $
#++

class Expression
#  @elements   # array

  def initialize( elements )
    @elements = elements
  end

  def print
    # puts "expr: #{@elements}"
    puts "expr_string: #{to_s}"
  end

  def to_s
    elements_to_s( @elements )
  end

  def to_str( name_list, ct_name )
    elements_to_s( @elements, name_list, ct_name )
  end

  # 
  # Ȥɾ
  #
  # Υ᥽åɤϡɾ
  # attribute, var ν
  # size_is, count_is 
  # ź
  #
  # name_list(NamedList|Nil): 黲Ȳǽʥꥹȡ
  # NamedList Ǥ  size_is, count_is ΰɾξ ParamDecl (ؿ)
  #
  # name_list2(NamedList|Nil) : NamedList Ǥ Decl (attribute, var) Ǥ롥ά nil
  # 
  # RETURN: ɾɾǤʤä nil ֤
  #
  # mikan  򻻽ФƤʤ
  #

  def eval_const( name_list, name_list2 = nil )
     elements_eval_const( @elements, name_list, name_list2 )
  end

  def get_type( namedList )        # ֤̾ NamedList 
    elements_get_type( @elements, namedList )
  end

  def check_dir_for_param( namedList, dir, spec )
    elements_check_dir_for_param( @elements, namedList, dir, spec )
  end

  def get_elements
    @elements
  end

  def show_tree( indent )
    # mikan override Ƥޤä print ƽФˡ狼ʤΤǤ
    str = ""
    indent.times { str += "  " }
    puts "#{str}#{to_s}"
  end

## private

  #=== ʸѴ
  #name_list:: attribute (Celltype::@attribute_list) ꤷƤ
  def elements_to_s( elements, name_list = nil, ct_name = "" )
    if elements.instance_of? Token then
      return elements.to_s    # OP_DOT, OP_REF α
    end

    case elements[0]
    when :IDENTIFIER
      if name_list && name_list.get_item( elements[1].to_s ) then
        # gen_ph_cb_initialize_macro ƽФ
        return "#{ct_name}_ATTR_#{elements[1]}(p_that)"
      else
        return  elements[1]
      end
    when :INTEGER_CONSTANT, :FLOATING_CONSTANT, :OCTAL_CONSTANT, :HEX_CONSTANT, :CHARACTER_LITERAL, :STRING_LITERAL_LIST
      return  elements[1]
    when :PARENTHESES
      return "(#{elements_to_s(elements[1])},name_list,ct_name)"
    when :OP_SUBSC
      return "#{elements_to_s(elements[1],name_list,ct_name)}[#{elements[2].to_s}]"
    when :OP_DOT
      return "#{elements_to_s(elements[1],name_list,ct_name)}.#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_REF
      return "#{elements_to_s(elements[1],name_list,ct_name)}->#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_SIZEOF_EXPR
      return "sizeof(#{elements_to_s(elements[1],name_list,ct_name)})"
    when :OP_SIZEOF_TYPE
      return "sizeof(#{elements[1]}) mikan"
    when :OP_U_AMP
      return "&#{elements_to_s(elements[1],name_list,ct_name)}"
    when :OP_U_ASTER
      return "*#{elements_to_s(elements[1],name_list,ct_name)}"
    when :OP_U_PLUS
      return "+#{elements_to_s(elements[1],name_list,ct_name)}"
    when :OP_U_MINUS
      return "-#{elements_to_s(elements[1],name_list,ct_name)}"
    when :OP_U_TILDE
      return "~#{elements_to_s(elements[1],name_list,ct_name)}"
    when :OP_U_EXCLAM
      return "!#{elements_to_s(elements[1],name_list,ct_name)}"
    when :CAST
      return "(#{elements[1].get_type_str})#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_MULT
      return "#{elements_to_s(elements[1],name_list,ct_name)}*#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_DIV
      return "#{elements_to_s(elements[1],name_list,ct_name)}/#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_REMAIN
      return "#{elements_to_s(elements[1],name_list,ct_name)}%#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_ADD
      return "#{elements_to_s(elements[1],name_list,ct_name)}+#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_SUB
      return "#{elements_to_s(elements[1],name_list,ct_name)}-#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_LSFT
      return "#{elements_to_s(elements[1],name_list,ct_name)}<<#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_RSFT
      return "#{elements_to_s(elements[1],name_list,ct_name)}>>#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_LT
      return "#{elements_to_s(elements[1],name_list,ct_name)}<#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_GT
      return "#{elements_to_s(elements[1],name_list,ct_name)}>#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_LE
      return "#{elements_to_s(elements[1],name_list,ct_name)}<=#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_GE
      return "#{elements_to_s(elements[1],name_list,ct_name)}>=#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_EQ
      return "#{elements_to_s(elements[1],name_list,ct_name)}==#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_NE
      return "#{elements_to_s(elements[1],name_list,ct_name)}!=#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_AND
      return "#{elements_to_s(elements[1],name_list,ct_name)}&#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_EOR
      return "#{elements_to_s(elements[1],name_list,ct_name)}^#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_OR
      return "#{elements_to_s(elements[1],name_list,ct_name)}|#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_LAND
      return "#{elements_to_s(elements[1],name_list,ct_name)}&&#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_LOR
      return "#{elements_to_s(elements[1],name_list,ct_name)}||#{elements_to_s(elements[2],name_list,ct_name)}"
    when :OP_CEX
      return "#{elements_to_s(elements[1],name_list,ct_name)}?#{elements_to_s(elements[2],name_list,ct_name)}:#{elements_to_s(elements[3],name_list,ct_name)}"
    end
    return ""
  end

  # (elements)ɾ
  #
  # Υ᥽åɤ Expression 饹Υ᥽åɤǤɬפϤʤʴؿǤ
  #
  # elements ϼ
  #
  # name_list, name_list2  eval_const 򻲾
  #
  # RETURN: ɾɾǤʤä nil ֤

  def elements_eval_const( elements, name_list, name_list2 = nil )
    case elements[0]
    when :IDENTIFIER
      if name_list then
        object = name_list.get_item( elements[1].get_name )
      end

      if object == nil && name_list2 then
        object = name_list2.get_item( elements[1].get_name )
      end

      # Ĥʤõ
      if object == nil then
        object = Namespace.find( [ elements[1].get_name ] )# mikan namespace б
      end

# μϡ⤦٤
# 줬ƽФΤϡʲξ
#   attribute, var αռɾ
#   size_is ɾؿѥ᡼ξattribute, var ξ礬
# ʲΥ顼åǤϡ餬äˤʤäƸ򸡽Ф褦ȤƤ

      # IDENTIFIER ϸĤʤä
      if object == nil then
        Generator.error( "#{elements[1]}: not found" )
        return nil
      elsif object.instance_of?( Join ) then
        # Join ξ硧 cell  attribute, var, call Τɤ줫Ĥä
        # Decl (attribute, var) Ǥʤ
        if ! object.get_definition.instance_of?( Decl ) then
          Generator.error( "#{elements[1]}: not constant (port)" )
          return nil
        end
        return object.get_rhs.eval_const( name_list, name_list2 )
      elsif ! object.instance_of?( Decl ) then
        # Decl Ǥʤ硧 Ǥʤ
        if ( ! object.instance_of?( ParamDecl ) ) then
                                                      # mikan paramdecl ̵뤹
                                                      # ParamList ƤФ줿Ȥ
          Generator.error( "#{elements[1]}: not constant" )
        end
        return nil
      elsif object.get_initializer == nil then
        # Ҥ¸ߤʤѿ
        return 0
      else
        # mikan size_is ˸ѿηŬڤΥå
        return object.get_initializer.eval_const( name_list, name_list2 )
      end
    when :BOOL_CONSTANT
      if( elements[1].instance_of?( TrueClass ) )then
        return "true"      # formerly tecs_true
      elsif( elements[1].instance_of?( FalseClass ) )then
        return "false"     # formerly tecs_false
      else
        throw( "BOOL constant error" )
      end
    when :INTEGER_CONSTANT
      return Integer( elements[1].val )
    when :FLOATING_CONSTANT
      return Float( elements[1].val )
    when :OCTAL_CONSTANT
      return elements[1].val.oct
    when :HEX_CONSTANT
      return elements[1].val.hex
    when :CHARACTER_LITERAL
      str =  elements[1].val.gsub(/'/, "" )
      if str.length == 1
        return str.sum
      else
        if str[0] == 92 then
          case str[1]
          when 48 # '0'
            return 0
          when 110 # 'n'
            return 10
          when 114 # 'r'
            return 13
          when 116 # 't'
            return 15
          when 92 # '\\'
            return 92
          end
        end
      end
      printf( "%c\n", str[1] )
      raise Error

    when :STRING_LITERAL_LIST
      return  elements[1]
    when :PARENTHESES
      return elements_eval_const( elements[1], name_list, name_list2 );
    when :OP_SUBSC
      return nil
    when :OP_DOT
      return nil
    when :OP_REF
      return nil
    when :OP_SIZEOF_EXPR
      return "sizeof(#{elements_to_s(elements[1])})"
    when :OP_SIZEOF_TYPE
      return "sizeof(#{elements[1]}) mikan"
    when :OP_U_AMP
      return nil
    when :OP_U_ASTER
      return nil
    when :OP_U_PLUS
      return elements_eval_const(elements[1], name_list, name_list2)
    when :OP_U_MINUS
      val = elements_eval_const(elements[1], name_list, name_list2)
      if val then
        return - val
      else
        return nil
      end
    when :OP_U_TILDE
      val = elements_eval_const(elements[1], name_list, name_list2)
      if val then
        return ~val
      else
        return nil
      end
    when :OP_U_EXCLAM
      return nil
    when :CAST
      return nil     # mikan cast 
    when :OP_MULT
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return lhs * rhs
    when :OP_DIV
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return lhs / rhs
    when :OP_REMAIN
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return lhs % rhs
    when :OP_ADD
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return lhs + rhs
    when :OP_SUB
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return lhs - rhs
    when :OP_LSFT
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return lhs << rhs
    when :OP_RSFT
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return lhs >> rhs
    when :OP_LT
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return ( lhs < rhs ) ? 1 : 0
    when :OP_GT
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return ( lhs > rhs ) ? 1 : 0
    when :OP_LE
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return ( lhs <= rhs ) ? 1 : 0
    when :OP_GE
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return ( lhs >= rhs ) ? 1 : 0
    when :OP_EQ
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return ( lhs >= rhs ) ? 1 : 0
    when :OP_NE
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      return ( lhs != rhs ) ? 1 : 0
    when :OP_AND
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum )
      return nil if( lhs.class != Fixnum )
      return lhs & rhs
    when :OP_EOR
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum )
      return nil if( lhs.class != Fixnum )
      return lhs ^ rhs
    when :OP_OR
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum )
      return nil if( lhs.class != Fixnum )
      return lhs | rhs
    when :OP_LAND
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum )
      return nil if( lhs.class != Fixnum )
      return ( lhs && rhs ) ? 1 : 0
    when :OP_LOR
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      rhs = elements_eval_const(elements[2], name_list, name_list2)
      return nil if( rhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum )
      return nil if( lhs.class != Fixnum )
      return ( lhs || rhs ) ? 1 : 0
    when :OP_CEX
      lhs = elements_eval_const(elements[1], name_list, name_list2)
      mhs = elements_eval_const(elements[2], name_list, name_list2)
      rhs = elements_eval_const(elements[3], name_list, name_list2)
      return nil if( rhs == nil || mhs == nil || lhs == nil )
      return nil if( rhs.class != Fixnum && rhs.class != Float )
      return nil if( mhs.class != Fixnum && mhs.class != Float )
      return nil if( lhs.class != Fixnum && lhs.class != Float )
      if lhs != 0 then
          return mhs
      else
          return rhs
      end
    end
    return nil
  end

  def elements_get_type( elements, namedList )
    type = elements_get_type_sub( elements, namedList )
    # ֤줿 DefinedType ξ η֤
    if type.kind_of?( DefinedType ) then
      type = type.get_type
    end
    return type
  end

  def elements_get_type_sub( elements, namedList )
    case elements[0]
    when :IDENTIFIER
      paramdecl = namedList.get_item( elements[1].val )
      unless paramdecl then
        Generator.error( "#{elements[1].val}: not found in parameter list" )
        return IntType.new(32)        # dummy result
      end
      return paramdecl.get_type
# mikan get_type
#    when :INTEGER_CONSTANT
#    when :FLOATING_CONSTANT
#    when :OCTAL_CONSTANT
#    when :HEX_CONSTANT
#    when :CHARACTER_LITERAL
#    when :STRING_LITERAL_LIST
#    when :PARENTHESES
#    when :OP_SUBSC
#    when :OP_DOT
#    when :OP_REF
#    when :OP_SIZEOF_EXPR
#    when :OP_SIZEOF_TYPE
#    when :OP_U_AMP
    when :OP_U_ASTER
      type = elements_get_type( elements[1], namedList )
      unless type.kind_of?( PtrType ) then
        Generator.error( "'*': operand is not pointer value" )
        return IntType.new( 8 )    # IntType ֤Ƥ
      end
      return type.get_referto

    when :OP_U_PLUS, :OP_U_MINUS
      # mikan operand ŬڤʷåƤʤ
      return elements_get_type( elements[1], namedList )

    when :OP_ADD, :OP_SUB, :OP_MULT, :OP_DIV, :OP_REMAIN
      # mikan operand ŬڤʷåƤʤդηѤƤ
      return elements_get_type( elements[1], namedList )

    when :OP_U_TILDE
      # mikan operand åƤʤ
      return elements_get_type( elements[1], namedList )
    when :OP_AND, :OP_EOR, :OP_OR, :OP_LSFT, :OP_RSFT
      # mikan operand åƤʤ
      return BoolType.new
    when :OP_U_EXCLAM
      # mikan operand åƤʤ
      return BoolType.new

    when :OP_LT, :OP_GT, :OP_LE, :OP_GE, :OP_EQ, :OP_NE, :OP_LAND, :OP_LOR, :OP_CEX, :CAST
      Generator.error( "#{elements[0]}: elements_get_type: sorry not supported" )
    end

    return nil
  end

  #  size_is, count_is, string ΰǤΥå
  def elements_check_dir_for_param( elements, namedList, dir, spec )
   # dir  ΰ
   # direct: size_is ʤɤΰѿ

    case elements[0]
    when :IDENTIFIER
      paramdecl = namedList.get_item( elements[1].val )

      return unless paramdecl      # if nil already error in element_get_type

      direct = paramdecl.get_direction
      judge = false
      case spec
      when "size_is", "string"
        case dir
        when :IN, :OUT, :INOUT, :SEND
          judge = true if ( direct == :IN || direct == :INOUT )
          req_direct = "in or inout"
        when :RECEIVE
          judge = true if ( direct == :OUT || direct == :INOUT )
          req_direct = "out or inout"
        end

      when "count_is"
        case dir
        when :IN, :SEND
          judge = true if ( direct == :IN || direct == :INOUT )
          req_direct = "in or inout"
        when :OUT, :RECEIVE
          judge = true if ( direct == :OUT || direct == :INOUT )
          req_direct = "out or inout"
        when :INOUT
          judge = true if ( direct == :INOUT )
          req_direct = "inout"
        end
      end

      if judge == false then
        Generator.error( "'#{elements[1].val}': direction mismatch for #{spec}, #{req_direct} required" )
      end

    when :INTEGER_CONSTANT, :FLOATING_CONSTANT, :OCTAL_CONSTANT, :HEX_CONSTANT, :CHARACTER_LITERAL, :STRING_LITERAL_LIST
      return true

    # ñ黻
    when :OP_U_ASTER, :OP_SIZEOF_EXPR, :OP_SIZEOF_TYPE, :OP_U_PLUS, :OP_U_MINUS, :OP_U_TILDE, :OP_U_EXCLAM, :CAST, :OP_U_AMP, :PARENTHESES,
      elements_check_dir_for_param( elements[1], namedList, dir, spec )

    # 2黻
    when :OP_SUBSC, :OP_DOT, :OP_REF, :OP_MULT, :OP_DIV, :OP_REMAIN, :OP_ADD, :OP_SUB, :OP_LSFT, :OP_RSFT, :OP_LT, :OP_GT, :OP_LE, :OP_GE, :OP_EQ, :OP_NE, :OP_AND, :OP_EOR, :OP_OR, :OP_LAND, :OP_LOR
      return elements_check_dir_for_param( elements[1], namedList, dir, spec ) && elements_check_dir_for_param( elements[2], namedList, dir, spec )

    # 3黻
    when :OP_CEX
      return elements_check_dir_for_param( elements[1], namedList, dir, spec ) && elements_check_dir_for_param( elements[2], namedList, dir, spec ) && elements_check_dir_for_param( elements[3], namedList, dir, spec )

    else
      Generator.error( "#{elements[0]}: elements_check_dir_for_param: sorry not supported" )
    end

  end


  private :elements_to_s, :elements_eval_const,  :elements_get_type

end


class C_EXP
# @c_exp_string : string
  def initialize( c_exp_string )
    #  " 
    @c_exp_string = c_exp_string.to_s.sub( /^\"(.*)\"$/, "\\1" )
  end

  def get_c_exp_string
    @c_exp_string
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "C_EXP: #{@c_exp_string}"
  end
end
